/*
	Copyright (C) 2004, Bruce Ediger

    This file is part of srf.

    srf is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#include <stdio.h>
#include <unistd.h>

#ident "$Id: rfunc.c,v 1.2 2004/11/02 04:39:45 bediger Exp $"

void usage(int);
void help(int);

extern int yyparse(void);

int
main(int ac, char **av)
{
	int flag;

	while (-1 != (flag = getopt(ac, av, "xXh")))
	{
		switch (flag)
		{
		case 'x':
		case 'X':  usage(1);     break;
		case 'h':  help(1);     break;
		}
	}

	return yyparse();
}

void
usage(int exitcode)
{
	fprintf(stderr, "A program to convert arithmetic expressions into\n"
		"simple recursive function bodies.\n");
	exit(exitcode);
}

void
help(exitcode)
{
	if (exitcode) exit(exitcode);
}
