/*
	Copyright (C) 2004, Bruce Ediger

    This file is part of srf.

    srf is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#ident "$Id: srf.h,v 1.7 2004/11/02 04:39:39 bediger Exp $"


enum valueType { UNSET, INTEGER, FUNCTION, IDENTIFIER, FILENAME};

struct value {
	enum valueType type;
	union {
		const char *identifier;
		const char *filename;
		int value;
		struct function *function;
	} v;
	int assigned;
	struct value *next;
};

/* argument list */
struct value_list {
	int cnt;
	int assigned;
	struct value *head;
	struct value *tail;
};

enum builtinType { NOFUNC, SUCCESSOR, ZERO, IDENTITY, COMPOSITION, PREC, CONSTRUCTOR, MIN};

struct function {

	struct value *(*function)(struct function *, struct value_list *);

	int debugflag;

	enum builtinType type;

	struct {
		int count;
		int index;
	} identity_data;

	struct {
		struct function *first;  /* pointer to "outermost" function */
		struct function **rest;   /* array (not list!) of inner function(s) */
	} composition_data;

	struct {
		struct function *zero;
		struct function *increment;
	} recursion_data;

	struct {
		struct function *function;
	} minimization_data;

	/* unused function pointers kept on a "free list" */
	struct function *next;
};

