/*
	Copyright (C) 2004, Bruce Ediger

    This file is part of srf.

    srf is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#ident "$Id: value.h,v 1.3 2004/11/02 04:39:39 bediger Exp $"

void setup_value_table(struct hashtable *h);

struct value *value_lookup(const char *id);
struct value *value_add(const char *id, struct value *v);

int evaluate(struct value *v);
struct function * value_function(struct value *v);
struct value *evaluate_function(struct function *f, struct value_list *vl);

struct value *new_value(void);
void free_value(struct value *v);

struct value_list *new_value_list(void);
void free_value_list(struct value_list *vl);

extern struct hashtable *value_table;

void print_value(struct value *v);

struct value_list *copy_and_evaluate(struct value_list *args);
struct value *copy_value(struct value *original);

void free_values(void);
